<!---
$Id$

Copyright 2007 Barney Boisvert (bboisvert@gmail.com).

Licensed under the Apache License, Version 2.0 (the "License"); you may
not use this file except in compliance with the License. You may obtain
a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
--->
<cfsetting enablecfoutputonly="true" />

<cfparam name="variables.attributes" type="struct" default="#structNew()#" />
<cfset structAppend(attributes, form, true) />
<cfset structAppend(attributes, url, true) />

<cfapplication name="schema_tool_demo" />

<cfset APP_LOADED_KEY = "applicationLoadedAt" />

<cfif structKeyExists(attributes, "reload")>
	<cfset structDelete(application, APP_LOADED_KEY, false) />
</cfif>

<cfif NOT structKeyExists(application, APP_LOADED_KEY)>
<cflock scope="application" type="exclusive" timeout="1" throwontimeout="true">
<cfif NOT structKeyExists(application, APP_LOADED_KEY)>
<cfscript>
	timestamp = now();
	
	// set up ColdSpring properties
	application.config = structNew();
	application.config.dsn = "schema_tool_demo";

	createObject("component", "schema_tool.tool").init(application.config.dsn, "schema_tool_demo.schema_scripts").ensureCurrent("#application.applicationname#.schema_tool");

	/* It's important that the schema tool does NOT get wired into
	   ColdSpring, and that it runs BEFORE ColdSpring is initialized, so
	   that any bean startup code that depends on the schema being up to
	   date will run successfully.  Further, the schema tool should not
	   have any dependencies to your application code
	
	application.factory = createObject("component", "coldspring.beans.DefaultXmlBeanFactory").init();
	application.factory.setDefaultProperties(application.config);
	application.factory.loadBeansFromXmlFile(getDirectoryFromPath(getCurrentTemplatePath()) & "applicationContext.xml", true);
	*/

	application[APP_LOADED_KEY] = timestamp;
</cfscript>
</cfif>
</cflock>
</cfif>